/****************************************/
/*    White Glove Tracking Data Set     */
/*    Started 05.21.2007                */
/*    Evan Roth evan@ni9e.com           */
/****************************************/
import processing.opengl.*;
import ddf.minim.*;
 
AudioPlayer song;

frame FM;
frame FMS[];
frame RAW[];
int comma;
String temp_f, temp_x, temp_y, temp_w, temp_h;
int f, x, y, w, h;
float t, inc, start_time, adj_time, current_time;

int counter;

PImage glove; 

float moved;
int xdist, ydist;
int fnum;

//Movie myMovie;

void setup(){
    size(640, 480, OPENGL);
    background(255);
    
    counter = 0;

    glove = loadImage("hand_icon.png");
    
     t = 0.0f;
     inc = 1.0f / 30.0f;
    
    //load in the text file
    String lines[] = loadStrings("wgt_data_v1.txt");
    println("there are " + lines.length + " lines");
    
    //make room for all objs
    RAW = new frame[lines.length];
    
    //loop through all lines
    //save data into frame objects
    for (int i=0; i < lines.length; i++) {

        //intit vars
        comma = 0;
        temp_f = "";
        temp_x = "";
        temp_y = "";
        temp_w = "";
        temp_h = "";
     
        //loop through all chars on the line
        for (int j=0; j < lines[i].length(); j++) {
        
            //this is the char we are looking at
            char c = lines[i].charAt(j);
        
            //which comma are we on
            if(c == ','){
                 comma++;
            }
        
            //break into multiple strings
            if(comma == 0){
               temp_f += c;
            }
            else if(comma == 1){
               if(c != ','){
                 temp_x += c;
               }
            }else if(comma == 2){
               if(c != ','){
                 temp_y += c;
               }
            }else if(comma == 3){
               if(c != ','){
                 temp_w += c;
               }
            }else if(comma == 4){
               if(c != ','){
                 temp_h += c;
               }
            }
        }
    
        //convert strings to ints
        f = int(temp_f);
        x = int(temp_x);
        y = int(temp_y);
        w = int(temp_w);
        h = int(temp_h);
        t += inc;
    
        //load data into object
        FM = new frame(f, x, y, w, h, t);
        RAW[i] = FM;
        //FMS[i].print();
    }
    
    FMS = RAW;
    
    
    //start Minim for audio
    Minim.start(this);
    song = Minim.loadFile("billyjean_amp.mp3");
    song.play();
}


void draw(){
    //find initial starting time
    if(counter == 0){
        start_time = millis()/1000.0f;
        println("start_time = " + start_time);
    }
   
   //animate here
   
   //animate by cpu clock
   current_time = millis()/1000.0f;
   adj_time = current_time - start_time;
   fnum = int(adj_time*29.96);
   //println("current_time = " + current_time + ", adj_time = " + adj_time);

   if(fnum < FMS.length){
     image(glove, FMS[fnum].x - (FMS[fnum].w / 2), FMS[fnum].y - (FMS[fnum].h / 2), FMS[fnum].h, FMS[fnum].w);
   }

   counter++;
}

void stop()
{
  song.close();
  super.stop();
}
